## GtkPadController GtkPadController — Controller for drawing tablet pads |

## Functions

GtkPadController * | gtk_pad_controller_new ()
void | gtk_pad_controller_set_action_entries ()
void | gtk_pad_controller_set_action ()

## Properties

GActionGroup * | action-group | Read / Write / Construct Only
GdkDevice * | pad | Read / Write / Construct Only

## Types and Values

| GtkPadController
enum | GtkPadActionType
struct | GtkPadActionEntry

## Object Hierarchy

        GObject
        ╰── GtkEventController
            ╰── GtkPadController

## Includes

    #include <gtk/gtk.h>

## Description

GtkPadController is an event controller for the pads found in drawing tablets (The collection of buttons and tactile sensors often found around the stylus-sensitive area).

These buttons and sensors have no implicit meaning, and by default they perform no action, this event controller is provided to map those to GAction objects, thus letting the application give those a more semantic meaning.

Buttons and sensors are not constrained to triggering a single action, some `GDK_SOURCE_TABLET_PAD` devices feature multiple "modes", all these input elements have one current mode, which may determine the final action being triggered. Pad devices often divide buttons and sensors into groups, all elements in a group share the same current mode, but different groups may have different modes. See `gdk_device_pad_get_n_groups()` and `gdk_device_pad_get_group_n_modes()`.

Each of the actions that a given button/strip/ring performs for a given mode is defined by GtkPadActionEntry, it contains an action name that will be looked up in the given GActionGroup and activated whenever the specified input element and mode are triggered.

A simple example of GtkPadController usage, assigning button 1 in all modes and pad devices to an "invert-selection" action:

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    GtkPadActionEntry *pad_actions[] = {
      { GTK_PAD_ACTION_BUTTON, 1, -1, "Invert selection", "pad-actions.invert-selection" },
      …
    };

    …
    action_group = g_simple_action_group_new ();
    action = g_simple_action_new ("pad-actions.invert-selection", NULL);
    g_signal_connect (action, "activate", on_invert_selection_activated, NULL);
    g_action_map_add_action (G_ACTION_MAP (action_group), action);
    …
    pad_controller = gtk_pad_controller_new (window, action_group, NULL);

The actions belonging to rings/strips will be activated with a parameter of type `G_VARIANT_TYPE_DOUBLE` bearing the value of the given axis, it is required that those are made stateful and accepting this GVariantType.

## Functions

### gtk_pad_controller_new ()

    GtkPadController *
    gtk_pad_controller_new (GtkWindow *window,
                            GActionGroup *group,
                            GdkDevice *pad);

Creates a new GtkPadController that will associate events from `pad` to actions. A `NULL` pad may be provided so the controller manages all pad devices generically, it is discouraged to mix GtkPadController objects with `NULL` and non-`NULL` `pad` argument on the same `window` , as execution order is not guaranteed.

The GtkPadController is created with no mapped actions. In order to map pad events to actions, use `gtk_pad_controller_set_action_entries()` or `gtk_pad_controller_set_action()`.

#### Parameters

window | a GtkWindow |
group | GActionGroup to trigger actions from |
pad | A `GDK_SOURCE_TABLET_PAD` device, or `NULL` to handle all pads. | [nullable]

#### Returns

A newly created GtkPadController

Since: 3.22

### gtk_pad_controller_set_action_entries ()

    void
    gtk_pad_controller_set_action_entries (GtkPadController *controller,
                                           const GtkPadActionEntry *entries,
                                           gint n_entries);

This is a convenience function to add a group of action entries on `controller` . See GtkPadActionEntry and `gtk_pad_controller_set_action()`.

#### Parameters

controller | a GtkPadController |
entries | the action entries to set on `controller` . | [array length=n_entries]
n_entries | the number of elements in `entries` |

Since: 3.22

### gtk_pad_controller_set_action ()

    void
    gtk_pad_controller_set_action (GtkPadController *controller,
                                   GtkPadActionType type,
                                   gint index,
                                   gint mode,
                                   const gchar *label,
                                   const gchar *action_name);

Adds an individual action to `controller` . This action will only be activated if the given button/ring/strip number in `index` is interacted while the current mode is `mode` . -1 may be used for simple cases, so the action is triggered on all modes.

The given `label` should be considered user-visible, so internationalization rules apply. Some windowing systems may be able to use those for user feedback.

#### Parameters

controller | a GtkPadController |
type | the type of pad feature that will trigger this action |
index | the 0-indexed button/ring/strip number that will trigger this action |
mode | the mode that will trigger this action, or -1 for all modes. |
label | Human readable description of this action, this string should be deemed user-visible. |
action_name | action name that will be activated in the GActionGroup |

Since: 3.22

## Types and Values

### GtkPadController

    typedef struct _GtkPadController GtkPadController;

### enum GtkPadActionType

The type of a pad action.

#### Members

GTK_PAD_ACTION_BUTTON | Action is triggered by a pad button |
GTK_PAD_ACTION_RING | Action is triggered by a pad ring |
GTK_PAD_ACTION_STRIP | Action is triggered by a pad strip |

### struct GtkPadActionEntry

    struct GtkPadActionEntry {
      GtkPadActionType type;
      gint index;
      gint mode;
      gchar *label;
      gchar *action_name;
    };

Struct defining a pad action entry.

#### Members

GtkPadActionType `type`; | the type of pad feature that will trigger this action entry. |
gint `index`; | the 0-indexed button/ring/strip number that will trigger this action entry. |
gint `mode`; | the mode that will trigger this action entry, or -1 for all modes. |
gchar *`label`; | Human readable description of this action entry, this string should be deemed user-visible. |
gchar *`action_name`; | action name that will be activated in the GActionGroup. |

## Property Details

### The `“action-group”` property

      “action-group”             GActionGroup *

Action group to launch actions from.

Flags: Read / Write / Construct Only

### The `“pad”` property

      “pad”                      GdkDevice *

Pad device to control.

Flags: Read / Write / Construct Only

## See Also

GtkEventController, GdkDevicePad